#include "module.h"
#include <regex.h>

#define AUTHOR "SGR" 
#define VERSION "1.00"

  /* ----------------------------------------------------------- 
   * Name: ns_listbyemail
   * Author: SGR <Alex_SGR@ntlworld.com> 
   * Date: 19/12/2003 
   * ----------------------------------------------------------- 
   * Functions: m_ns_dropbyemail. 
   * Limitations: None Known.
   * Tested: Ultimate(2.8.x), Unreal(3.2), Bahamut
   * ----------------------------------------------------------- 
   * This version has been tested on Ultimate2.8.6, Unreal and 
   * Bahamut. All IRCd's should be compatible with this module. 
   * 
   * This module is designed to aid Services Admins in cleaning
   * up after NickServ registration attacks and in dropping or
   * foribdding nicks em-mass based on their e-mail address.
   *
   *  Please set the config options below. 
   *
   * ----------------------------------------------------------- 
   *  ChangeLog
   *
   *  1) Works
   * 
   * -----------------------------------------------------------*/ 
    
/* ---------------------------------------------------------------------- */ 
/* START OF CONFIGURATION BLOCK - please read the comments :)             */ 
/* ---------------------------------------------------------------------- */ 

#define LIST_BY_MAIL_SYNTAX "SYNTAX: LISTBYEMAIL email-address@can-be.wildcarded FORBID [reason]"
#define LIST_BY_MAIL_SYNTAX2 "SYNTAX: LISTBYEMAIL email-address@can-be.wildcarded LIST [GROUPS]"
#define LISTBYEMAIL_KILL_REASON "Using FORBIDDEN Nick"

/* ---------------------------------------------------------------------- */
/* DO NOT EDIT BELOW THIS LINE UNLESS YOU KNOW WHAT YOU ARE DOING         */
/* ---------------------------------------------------------------------- */
#define PRINT 1
#define CNTRL 2
#define ALPHA 4
#define PUNCT 8
#define DIGIT 16
#define SPACE 32
#define isspacea(c) (char_atribs[(u_char)(c)]&SPACE)
#define isdigita(c) (char_atribs[(u_char)(c)]&DIGIT)
#define        isvalida(c) (((c) >= 'A' && (c) < '~') || isdigita(c) || (c) == '-')
int m_ns_dropbyemail(User * u);
int m_do_nick_check(char *nick);
void SGR_Module_Help_NICKSERV_LISTBYEMAIL(User *u);
int SGR_Module_Help_NICKSERV_LISTBYEMAIL_FULL(User *u);
int match_regexp(char *pattern, char *text);
NickCore *nclists[1024];
unsigned char char_atribs[] =
{
    CNTRL, CNTRL, CNTRL, CNTRL, CNTRL, CNTRL, CNTRL, CNTRL, CNTRL, CNTRL | SPACE, CNTRL | SPACE, CNTRL | SPACE, CNTRL | SPACE,
    CNTRL | SPACE, CNTRL, CNTRL, CNTRL, CNTRL, CNTRL, CNTRL, CNTRL, CNTRL, CNTRL, CNTRL, CNTRL, CNTRL, CNTRL, CNTRL, CNTRL,
    CNTRL, CNTRL, CNTRL, PRINT | SPACE, PRINT, PRINT, PRINT, PRINT, PRINT, PRINT, PRINT, PRINT, PRINT, PRINT, PRINT, PRINT, 
    PRINT, PRINT, PRINT, PRINT | DIGIT, PRINT | DIGIT, PRINT | DIGIT, PRINT | DIGIT, PRINT | DIGIT, PRINT | DIGIT, PRINT | 
    DIGIT, PRINT | DIGIT, PRINT | DIGIT, PRINT | DIGIT, PRINT, PRINT, PRINT, PRINT, PRINT, PRINT, PRINT, PRINT | ALPHA,
    PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA,
    PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, 
    PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA,
    PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT, PRINT, PRINT | ALPHA, PRINT | ALPHA, 
    PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, 
    PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA,
    PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA,
    PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, PRINT | ALPHA, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
};

int AnopeInit(int argc, char **argv)
{ 
   Command *c; 
   alog("Loading module ns_dropbyemail.so"); 
   c = createCommand("LISTBYEMAIL", m_ns_dropbyemail, is_services_admin,-1,-1,-1,-1,-1); 
   moduleAddCommand(NICKSERV, c, MOD_UNIQUE);
   moduleAddHelp(c,SGR_Module_Help_NICKSERV_LISTBYEMAIL_FULL);
   moduleSetNickHelp(SGR_Module_Help_NICKSERV_LISTBYEMAIL);
   alog("[ns_dropbyemail] NEW Command added: /msg %s LISTBYEMAIL", s_NickServ); 
   alog("[ns_dropbyemail] Yayness!(tm) - MODULE LOADED AND ACTIVE"); 
   return MOD_CONT; 
} 

void SGR_Module_Help_NICKSERV_LISTBYEMAIL(User *u)
{
   if (is_services_admin(u)) {
       notice(s_NickServ,u->nick, "    LISTBYEMAIL Forbid or list nicks based on e-mail.");
   }
   return;
}

int SGR_Module_Help_NICKSERV_LISTBYEMAIL_FULL(User *u)
{
   if (is_services_admin(u)) {
       notice(s_NickServ,u->nick, "-------------------------------------------------------------");
       notice(s_NickServ,u->nick, LIST_BY_MAIL_SYNTAX); 
       notice(s_NickServ,u->nick, LIST_BY_MAIL_SYNTAX2);
       notice(s_NickServ,u->nick, " "); 
       notice(s_NickServ,u->nick, "This command allows services admins and above to list and"); 
       notice(s_NickServ,u->nick, "forbid nicks 'en-mass' based on an e-mail address mask. "); 
       notice(s_NickServ,u->nick, " "); 
       notice(s_NickServ,u->nick, "The e-mail address provided must be in the format: "); 
       notice(s_NickServ,u->nick, " *<user>@<domain>.<tld>  (This can be - and is - wildcarded)"); 
              notice(s_NickServ,u->nick, " "); 
       notice(s_NickServ,u->nick, " For example, some valid masks are: "); 
       notice(s_NickServ,u->nick, " "); 
       notice(s_NickServ,u->nick, "    *test@test.com"); 
       notice(s_NickServ,u->nick, "    *@test.com"); 
       notice(s_NickServ,u->nick, "    *test@*.test.com");
       notice(s_NickServ,u->nick, "    *te?t*@???.t*.com");
       notice(s_NickServ,u->nick, "    ???@*.*");
       notice(s_NickServ,u->nick, "    *@*.*");
       notice(s_NickServ,u->nick, " "); 
       notice(s_NickServ,u->nick, " The starting * is required, as is atleast one . and @ sign. "); 
       notice(s_NickServ,u->nick, " Should the LIST option be used, matches will be listed back "); 
       notice(s_NickServ,u->nick, " to the Services Admin calling the command without any further"); 
       notice(s_NickServ,u->nick, " action. Should the the 'GROUPS' parameter be provided, only");
       notice(s_NickServ,u->nick, " the display nicks of matches will be shown."); 
       notice(s_NickServ,u->nick, " If FORBID is used, all matches will be FORBIDDEN, and"); 
       notice(s_NickServ,u->nick, " any 'in-use' matches KILLED."); 
       notice(s_NickServ,u->nick, "-------------------------------------------------------------");
   }
   return MOD_CONT;
}

int m_ns_dropbyemail(User * u) 
{
   // LISTBYEMAIL addy@addy.addy [FORBID|LIST] [GROUPS|REASON]
   //
   int dropped=0;
   int action =0;  /* no, i don't wan't all these defines on one "int count=0, action=0, blah=0;" line. */
   int countx =0;
   int go=0;
   int i =0;
   int k =0;
   char *arg1 = strtok(NULL," ");
   char *arg2 = strtok(NULL," ");
   char *arg3 = strtok(NULL,"");
   NickAlias *na2;
   NickCore  *nc;
   if (!arg1 || !arg2) { 
       notice(s_NickServ, u->nick, LIST_BY_MAIL_SYNTAX);
       notice(s_NickServ, u->nick, LIST_BY_MAIL_SYNTAX2);
       return MOD_CONT;
   }
   if (!(!stricmp(arg2,"forbid") || !stricmp(arg2,"list"))) {
        notice(s_NickServ, u->nick, LIST_BY_MAIL_SYNTAX);
        notice(s_NickServ, u->nick, LIST_BY_MAIL_SYNTAX2);
        return MOD_CONT;
   }
   if (!stricmp(arg2,"forbid")) {
       action=2;
       if (ForceForbidReason && !arg3) {
           notice(s_NickServ, u->nick, "ERROR: A reason must be provided with the FORBID option.");
           return MOD_CONT;
       }
   }
   if (!stricmp(arg2,"list")) {
       action=0; 
   }
   if (arg3) {
       if (!action && !stricmp(arg3,"GROUPS")) {
           go=1;
       }
   }
   if (!strchr(arg1, '@') || !strchr(arg1, '.') || !match_regexp(arg1,"\\^[A-Z0-9._%-]+@[A-Z0-9._%-]+\\.[A-Z0-9._%-]{2,4}\\$")) {
        notice(s_NickServ, u->nick, "Invalid e-mail address format. Please specify addresses to fit the mask *@*.* ");
        return MOD_CONT;
   }
   if (readonly && (action > 0)) {
        notice(s_NickServ, u->nick, "ERROR: Services in READONLY mode.");
        return MOD_CONT;
   }  
   for (k = 0; k < 1024; k++) {
        for (nc = nclists[k]; nc != NULL; nc = nc->next) {
             if (nc == NULL) {
                 break;
             }
	     //alog("Checking %s %s %s", nc->display, nc->email, arg1); 
             if (!m_do_nick_check(nc->display)) {
                 //Invalid nick in user record - bypass it.
                 continue;
             }
             if (nc->email) {
                 if (match_wild_nocase(arg1, nc->email)) {    
                     if (action == 0) {
                         countx = nc->aliases.count;
                         notice(s_NickServ, u->nick, "Group Match: %-14s [%-20s] (Aliases: %d)", nc->display, nc->email, countx);
			 if (go == 1) {
			     dropped++;
                             continue;
			 } 
                         for (i = 0; i < nc->aliases.count; i++) {
                              na2 = nc->aliases.list[i];
                              if (na2->nc == nc) {
                                  notice(s_NickServ, u->nick, "  `-- Match: [%d] - %-12s", i, na2->nick);
                              }
                         }
                         dropped++;
                         continue;
                     }
		     /* Seriously fucked up */
                     /*if (action == 1) {
                         int  t=0;
                         int  t2=0;
                         countx = nc->aliases.count;
                         notice(s_NickServ, u->nick, "Dropping Group: %-14s [%-20s] (Aliases: %d)", nc->display, nc->email, countx);
                         while (nc->aliases.count) {
                                    t2++;
                                    na2 = nc->aliases.list[t];
                                    notice(s_NickServ, u->nick, "  `-- Dropping: [%d] [%d] - %-12s", t, t2, na2->nick);
                                    delnick(na2);
                         }
                         dropped++;
                         continue;
                    }*/ 
                    if (action == 2) {
                        countx = nc->aliases.count;
                        notice(s_NickServ, u->nick, "Forbidding Group: %-14s [%-20s] (Aliases: %d)", nc->display, nc->email, countx);
 			if (nc->email) {
                            free(nc->email);
			}
                        for (i = 0; i < nc->aliases.count; i++) {
                             na2 = nc->aliases.list[i];
                             if (na2->nc == nc) {
                                 na2->status |= NS_VERBOTEN;
                                 na2->last_usermask = sstrdup(u->nick);
                                 if (arg3) {
                                     na2->last_realname = sstrdup(arg3);
                                 }
                                 if (na2->last_quit) {
                                     free(na2->last_quit);
				 }
                                 notice(s_NickServ, u->nick, "  `-- Forbidding: %d - %-14s", i, na2->nick);
                                 if (finduser(na2->nick)) {
                                     kill_user(s_NickServ, na2->u->nick, LISTBYEMAIL_KILL_REASON);
                                 }
                             }
                        }
                        dropped++;
                        continue;
                    }
                    if (nc->next == NULL) { 
                         break;
                    } 
                 }
             }
        }
   }
   notice(s_NickServ, u->nick, "Total number of groups illiciting action: %d", dropped);
   return MOD_CONT;
}

/* Thanks to Keeper for this */
int match_regexp(char *pattern, char *text)
{
   regex_t regex;
   int err;
   
   if (!pattern || !text) {
       return 0;
   }
   if (!(err = regcomp(&regex, pattern, REG_EXTENDED | REG_NOSUB))) {
       if (regexec(&regex, text, 0, 0, 0) == 0) {
           regfree(&regex);
           return 1;
       } 
   }
   regfree(&regex);
   if (!err) { 
       return 0;
   }
   return err;
}

int m_do_nick_check(char *nick) 
{
  char   *check;
  if (*nick == '-' || isdigita(*nick)) {        /* first character is [0..9-] */
      return 0;
  }
  for (check = nick; *check && (check - nick) < NICKMAX; check++) {
      if (!isvalida(*check) || isspacea(*check)) {
          return 0;
          break;
      }
  }
  return 1;
}


